/*

Scanner.java
  -- classes implementing a scanner for interval arithmetic expressions,
     as part of the "ia_parser library" version 0.1beta1, 10/97

Copyright (C) 1997 Timothy J. Hickey

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

 */




package ia_parser;

import java_cup.runtime.*;
import java.io.*;

/**
 * This generates lexical scanners for the IAparser applications
 */
class Scanner {
  InputStream prog = System.in;

  private static Yylex lexer;
  private static Yytoken current;


  /* initialize the scanner */
  void init()
    throws java.io.IOException
    {
      lexer = new Yylex(prog);
      current = lexer.yylex();
    }

  /* initialize the lexer */
  void set_input(String s) {
      prog = new StringBufferInputStream(s);
  }

  /* recognize and return the next complete token */
  Symbol next_token()
    throws java.io.IOException
    {Yytoken last;
     Object xx=null;

     //      System.out.println("current token: "+current.m_text+" "+current.m_index+ "  ");

      if (current == null) return new Symbol(sym.EOF);
      else {
        if (current.m_index == sym.NUMBER)
	  //           xx = (Integer) new (Integer.parseInt(current.m_text));
	  try {
            xx = Double.valueOf(current.m_text);
        } catch (Exception e) {                        // catch exceptions
          System.out.println("Error in Tokens " + e+"\n  "+current.m_text);
	}
        else xx = current.m_text;

        last = current;
        current = lexer.yylex();
        return new Symbol(last.m_index,xx);
      }
    }
}


